
 'ObjectOne.inc

TYPE tObjectOne
    lActive AS LONG
    eConstructor AS DWORD
    eDeconstructor AS DWORD
    lMyVar1 AS LONG
    lMyVar2 AS LONG
    eSet2From1 AS DWORD
    oParent_Object AS oObject
END TYPE
MACRO oObjectOne = tObjectOne PTR


SUB ObjectOne_Set2From1(poObj AS DWORD, ptpPrm AS DWORD)
    LOCAL loObj AS oObjectOne
    loObj = poObj
    @loObj.lMyVar2 = @loObj.lMyVar1
END SUB


SUB KillObjectOne(poObj AS DWORD, OPTIONAL ptpPrm AS DWORD)
    LOCAL loObj AS oObjectOne
    loObj = poObj
    'Kill parents
        KillObject @loObj.oParent_Object
    'De-Alloc memory
        ObjectAlloc %False, poObj
END SUB


FUNCTION NewObjectOne AS DWORD
    LOCAL loObj AS oObjectOne

    'Alloc memory
        loObj = ObjectAlloc(%True, SIZEOF(@loObj))
        IF loObj = %False THEN EXIT FUNCTION

    'Create parents
        @loObj.oParent_Object = NewObject
        IF @loObj.oParent_Object = %False THEN
            ObjectAlloc %False, loObj
            EXIT FUNCTION
        END IF

    'Set defaults
        @loObj.lActive = %True
        @loObj.eConstructor = CODEPTR(NewObjectOne)
        @loObj.eDeconstructor = CODEPTR(KillObjectOne)
        @loObj.lMyVar1 = 1
        @loObj.lMyVar2 = 2
        @loObj.eSet2From1 = CODEPTR(ObjectOne_Set2From1)

    'Return pointer
        FUNCTION = loObj
END FUNCTION
