
   'ObjectOneWithTwo.inc

TYPE tObjectOneWithTwo
    lActive AS LONG
    eConstructor AS DWORD
    eDeconstructor AS DWORD
    spName AS STRING PTR
    lpMyVar1 AS LONG PTR
    lpMyVar2 AS LONG PTR
    lpMyVar3 AS LONG PTR
    lpMyVar4 AS LONG PTR
    eSet2From1 AS DWORD
    eSet4From3 AS DWORD
    eSet4From1 AS DWORD
    eSetMCase AS DWORD
    oParent_ObjectOne AS oObjectOne
    oParent_ObjectTwo AS oObjectTwo
END TYPE
MACRO oObjectOneWithTwo = tObjectOneWithTwo PTR


SUB ObjectOneWithTwo_Set2From1(poObj AS DWORD, ptpPrm AS DWORD)
    LOCAL loObj AS oObjectOneWithTwo
    loObj = poObj
    mObjCall(@loObj.oParent_ObjectOne, @loObj.@oParent_ObjectOne.eSet2From1, ptpPrm)
END SUB


SUB ObjectOneWithTwo_Set4From3(poObj AS DWORD, ptpPrm AS DWORD)
    LOCAL loObj AS oObjectOneWithTwo
    loObj = poObj
    mObjCall(@loObj.oParent_ObjectTwo, @loObj.@oParent_ObjectTwo.eSet4From3, ptpPrm)
END SUB


SUB ObjectOneWithTwo_Set4From1(poObj AS DWORD, ptpPrm AS DWORD)
    LOCAL loObj AS oObjectOneWithTwo
    loObj = poObj
    @loObj.@lpMyVar4 = @loObj.@lpMyVar1
END SUB


SUB ObjectOneWithTwo_SetMCase(poObj AS DWORD, ptpPrm AS DWORD)
    LOCAL loObj AS oObjectOneWithTwo
    loObj = poObj
    @loObj.@spName = MCASE$(@loObj.@spName)
END SUB


SUB KillObjectOneWithTwo(poObj AS DWORD, OPTIONAL ptpPrm AS DWORD)
    LOCAL loObj AS oObjectOneWithTwo
    loObj = poObj
    'Kill parents
        KillObjectOne @loObj.oParent_ObjectOne
        KillObjectTwo @loObj.oParent_ObjectTwo
    'De-Alloc memory
        ObjectAllocString %False, @loObj.@spName
        ObjectAlloc %False, poObj
END SUB


FUNCTION NewObjectOneWithTwo AS DWORD
    LOCAL loObj AS oObjectOneWithTwo

    'Alloc memory
        loObj = ObjectAlloc(%True, SIZEOF(@loObj))
        IF loObj = %False THEN EXIT FUNCTION

    'Create parents
        @loObj.oParent_ObjectOne = NewObjectOne
        IF @loObj.oParent_ObjectOne = %False THEN
            ObjectAlloc %False, loObj
            EXIT FUNCTION
        END IF
        @loObj.oParent_ObjectTwo = NewObjectTwo
        IF @loObj.oParent_ObjectOne = %False THEN
            ObjectAlloc %False, loObj
            EXIT FUNCTION
        END IF

    'Set defaults
        @loObj.lActive = %True
        @loObj.eConstructor = CODEPTR(NewObjectOneWithTwo)
        @loObj.eDeconstructor = CODEPTR(KillObjectOneWithTwo)
        @loObj.lpMyVar1 = VARPTR(@loObj.@oParent_ObjectOne.lMyVar1)
        @loObj.lpMyVar2 = VARPTR(@loObj.@oParent_ObjectOne.lMyVar2)
        @loObj.lpMyVar3 = VARPTR(@loObj.@oParent_ObjectTwo.lMyVar3)
        @loObj.lpMyVar4 = VARPTR(@loObj.@oParent_ObjectTwo.lMyVar4)
        @loObj.spName = ObjectAllocString(%True, "No Name")
        @loObj.eSet2From1 = CODEPTR(ObjectOneWithTwo_Set2From1)
        @loObj.eSet4From3 = CODEPTR(ObjectOneWithTwo_Set4From3)
        @loObj.eSet4From1 = CODEPTR(ObjectOneWithTwo_Set4From1)
        @loObj.eSetMCase = CODEPTR(ObjectOneWithTwo_SetMCase)

    'Return pointer
        FUNCTION = loObj
END FUNCTION
