

'ObjectOne_A.inc

TYPE tObjectOne_A
    lActive AS LONG
    eConstructor AS DWORD
    eDeconstructor AS DWORD
    spMyVar1 AS STRING PTR
    spMyVar2 AS STRING PTR
    eSet2From1 AS DWORD
    oParent_ObjectOne AS oObjectOne
END TYPE
MACRO oObjectOne_A = tObjectOne_A PTR


SUB ObjectOne_A_Set2From1(poObj AS DWORD, ptpPrm AS DWORD)
    LOCAL loObj AS oObjectOne_A
    loObj = poObj
    @loObj.@spMyVar2 = @loObj.@spMyVar1
END SUB


SUB KillObjectOne_A(poObj AS DWORD, OPTIONAL ptpPrm AS DWORD)
    LOCAL loObj AS oObjectOne_A
    loObj = poObj
    'Kill parents
        KillObjectOne @loObj.oParent_ObjectOne
    'De-Alloc memory
        ObjectAllocString %False, @loObj.@spMyVar1
        ObjectAllocString %False, @loObj.@spMyVar2
        ObjectAlloc %False, poObj
END SUB


FUNCTION NewObjectOne_A AS DWORD
    LOCAL loObj AS oObjectOne_A

    'Alloc memory
        loObj = ObjectAlloc(%True, SIZEOF(@loObj))
        IF loObj = %False THEN EXIT FUNCTION

    'Create parents
        @loObj.oParent_ObjectOne = NewObjectOne
        IF @loObj.oParent_ObjectOne = %False THEN
            ObjectAlloc %False, loObj
            EXIT FUNCTION
        END IF

    'Set defaults
        @loObj.lActive = %True
        @loObj.eConstructor = CODEPTR(NewObjectOne_A)
        @loObj.eDeconstructor = CODEPTR(KillObjectOne_A)
        @loObj.spMyVar1 = ObjectAllocString(%True, "1")
        @loObj.spMyVar2 = ObjectAllocString(%True, "2")
        @loObj.eSet2From1 = CODEPTR(ObjectOne_A_Set2From1)

    'Return pointer
        FUNCTION = loObj
END FUNCTION
