


'ObjectOne_A_A.inc

TYPE tObjectOne_A_A
    lActive AS LONG
    eConstructor AS DWORD
    eDeconstructor AS DWORD
    lMessItUp AS LONG 'A test to ensure this Obj's mem is different from parent to prove OO correctness.
    spMyVar1 AS STRING PTR
    spMyVar2 AS STRING PTR
    spMyVar3 AS STRING PTR
    spMyVar4 AS STRING PTR
    eSet2From1 AS DWORD
    eSet4From1 AS DWORD
    oParent_ObjectOne_A AS oObjectOne_A
END TYPE
MACRO oObjectOne_A_A = tObjectOne_A_A PTR


SUB ObjectOne_A_A_Set2From1(poObj AS DWORD, ptpPrm AS DWORD)
    LOCAL loObj AS oObjectOne_A_A
    loObj = poObj
    mObjCall(@loObj.oParent_ObjectOne_A, @loObj.@oParent_ObjectOne_A.eSet2From1, ptpPrm)
END SUB


SUB ObjectOne_A_A_Set4From1(poObj AS DWORD, ptpPrm AS DWORD)
    LOCAL loObj AS oObjectOne_A_A
    loObj = poObj
    @loObj.@spMyVar4 = @loObj.@spMyVar1
END SUB


SUB KillObjectOne_A_A(poObj AS DWORD, OPTIONAL ptpPrm AS DWORD)
    LOCAL loObj AS oObjectOne_A_A
    loObj = poObj
    'Kill parents
        KillObjectOne_A @loObj.oParent_ObjectOne_A
    'De-Alloc memory
        ObjectAllocString %False, @loObj.@spMyVar3
        ObjectAllocString %False, @loObj.@spMyVar4
        ObjectAlloc %False, poObj
END SUB


FUNCTION NewObjectOne_A_A AS DWORD
    LOCAL loObj AS oObjectOne_A_A

    'Alloc memory
        loObj = ObjectAlloc(%True, SIZEOF(@loObj))
        IF loObj = %False THEN EXIT FUNCTION

    'Create parents
        @loObj.oParent_ObjectOne_A = NewObjectOne_A
        IF @loObj.oParent_ObjectOne_A = %False THEN
            ObjectAlloc %False, loObj
            EXIT FUNCTION
        END IF

    'Set defaults
        @loObj.lActive = %True
        @loObj.eConstructor = CODEPTR(NewObjectOne_A_A)
        @loObj.eDeconstructor = CODEPTR(KillObjectOne_A_A)
        @loObj.spMyVar1 = @loObj.@oParent_ObjectOne_A.spMyVar1
        @loObj.spMyVar2 = @loObj.@oParent_ObjectOne_A.spMyVar2
        @loObj.spMyVar3 = ObjectAllocString(%True, "three")
        @loObj.spMyVar4 = ObjectAllocString(%True, "four")
        @loObj.eSet2From1 = CODEPTR(ObjectOne_A_A_Set2From1)
        @loObj.eSet4From1 = CODEPTR(ObjectOne_A_A_Set4From1)

    'Return pointer
        FUNCTION = loObj
END FUNCTION
