
  'ObjectTwo.inc

TYPE tObjectTwo
    lActive AS LONG
    eConstructor AS DWORD
    eDeconstructor AS DWORD
    lMyVar3 AS LONG
    lMyVar4 AS LONG
    eSet4From3 AS DWORD
    oParent_Object AS oObject
END TYPE
MACRO oObjectTwo = tObjectTwo PTR


SUB ObjectTwo_Set4From3(poObj AS DWORD, ptpPrm AS DWORD)
    LOCAL loObj AS oObjectTwo
    loObj = poObj
    @loObj.lMyVar4 = @loObj.lMyVar3
END SUB


SUB KillObjectTwo(poObj AS DWORD, OPTIONAL ptpPrm AS DWORD)
    LOCAL loObj AS oObjectTwo
    loObj = poObj
    'Kill parents
        KillObject @loObj.oParent_Object
    'De-Alloc memory
        ObjectAlloc %False, poObj
END SUB


FUNCTION NewObjectTwo AS DWORD
    LOCAL loObj AS oObjectTwo

    'Alloc memory
        loObj = ObjectAlloc(%True, SIZEOF(@loObj))
        IF loObj = %False THEN EXIT FUNCTION

    'Create parents
        @loObj.oParent_Object = NewObject
        IF @loObj.oParent_Object = %False THEN
            ObjectAlloc %False, loObj
            EXIT FUNCTION
        END IF

    'Set defaults
        @loObj.lActive = %True
        @loObj.eConstructor = CODEPTR(NewObjectTwo)
        @loObj.eDeconstructor = CODEPTR(KillObjectTwo)
        @loObj.lMyVar3 = 3
        @loObj.lMyVar4 = 4
        @loObj.eSet4From3 = CODEPTR(ObjectTwo_Set4From3)

    'Return pointer
        FUNCTION = loObj
END FUNCTION
